/* Copyright (C) 1992 Imperial College */
/* This is the header file for the primitive/service functions */

/* service functions have negative escape numbers */
#define PR_noref	-3
#define PR_debugicp	-2
#define PR_halt		-1

/* primitive functions have positive escape numbers */
#define PR_add		0
#define PR_subtract	1
#define PR_multiply	2
#define PR_divide	3
#define PR_mod		4
#define PR_cmp		5
#define PR_integer	6
#define PR_atom		7
#define PR_var		8
#define PR_list		9
#define PR_tpl		10
#define PR_getarg	11
#define PR_tpl_to_list	12
#define PR_name		13
#define PR_open_stream	14
#define PR_close_stream	15
#define PR_open_ram	16
#define PR_close_ram	17
#define PR_set_input	18
#define PR_set_output	19
#define PR_increment	20
#define PR_put_q_atom	21
#define PR_charin	22
#define PR_charout	23
#define PR_charback	24
#define PR_flush	25
#define PR_addr		26
#define PR_deepcut	27
#define PR_back		28
#define PR_meta		29
#define PR_eq		30
#define PR_ne		31
#define PR_lt		32
#define PR_le		33
#define PR_gt		34
#define PR_ge		35
#define PR_syntax_error	36
#define PR_link		37
#define PR_retract	38
#define PR_dec		39
#define PR_inc		40
#define PR_find_clause	41
#define PR_time		42
#define PR_arity	43
#define PR_funct	44
#define PR_interm	45
#define PR_ntpl		46
#define PR_not		47
#define PR_lshift	48
#define PR_rshift	49
#define PR_and		50
#define PR_or		51
#define PR_op_prefix	52
#define PR_op_postfix	53
#define PR_op_infix	54
#define PR_op_look	55
#define PR_op_get	56
#define PR_put_str	57
#define PR_put_atom	58
#define PR_put_number	59
#define PR_atom_type	60
#define PR_defined	61
#define PR_read_catch	62
#define PR_set_catch	63
#define PR_read_error	64
#define PR_catch	65
#define PR_throw	66
#define PR_cg_init	67
#define PR_cg_fixup	68
#define PR_cg		69
#define PR_system	70
#define PR_ram_const	71
#define PR_load		72
#define PR_varsin	73
#define PR_fix_tables	74
#define PR_save		75
#define PR_pred_look	76
#define PR_pred_get	77
#define PR_abolish	78
#define	PR_validate	79
#define PR_undo_seg	80
#define PR_kill		81
#define PR_write_term	82
#define PR_read_term	83
#define PR_tag		84
#define PR_grnd_funct	85
#define PR_tab		86
#define PR_concat	87
#define PR_prefix	88
#define PR_suffix	89
#define PR_to_ground	90
#define PR_to_hollow	91
#define PR_delete	92
#define PR_cg_out	93
#define PR_set_up_seg	94
#define PR_tty		95
#define PR_ram_pipe	96
#define PR_close_port	97
#define PR_read_pipe	98
#define PR_write_pipe	99
#define PR_new_thread	100
#define PR_kill_thread	101
#define PR_fork		102
#define PR_resume	103
#define PR_suspend	104
#define PR_rpc		105
#define PR_pipe		106
#define PR_thread	107
#define PR_set_prop	108
#define PR_get_prop	109
#define PR_del_prop	110
#define PR_get_props	111
#define PR_del_props	112
#define PR_get_cons	113
#define PR_del_cons	114
#define PR_float	115
#define PR_put_float	116
#define PR_number	117
#define PR_fadd		118
#define PR_fsub		119
#define PR_fmul		120
#define PR_fdiv		121
#define PR_int		122
#define PR_sin		123
#define PR_cos		124
#define PR_tan		125
#define PR_asin		126
#define PR_acos		127
#define PR_atan		128
#define PR_atan2	129
#define PR_sinh		130
#define PR_cosh		131
#define PR_tanh		132
#define PR_exp		133
#define PR_log		134
#define PR_log10	135
#define PR_sqrt		136
#define PR_pow		137
#define PR_abs		138
#define PR_sign		139
#define PR_ceil		140
#define PR_floor	141
#define PR_pi		142
#define PR_rand		143
#define PR_deg2rad	144
#define PR_rad2deg	145
#define PR_interrupt	146
#define PR_unix		147
#define PR_stat		148
#define PR_look_pipe	149
#define PR_commit_read	150
#define PR_unlock	151
#define PR_init_parlog	152
#define PR_tty_get0	153
#define PR_curr_input	154
#define PR_curr_output	155
#define PR_release_port	156
#define PR_empty_pipe	157
#define PR_is_iport	158
#define PR_is_oport	159
#define PR_runtime	160
#define PR_decrement	161
#define PR_exit		162
#define PR_set_port	163
#define PR_get_port	164
#define PR_gensym	165
#define PR_ar_int	166
#define PR_ar_float	167
#define PR_copy		168
#define PR_load_foreign	170
#define PR_realtime	171
#define PR_errno	172
#define PR_getenv	173
#define PR_timeslice	174
#define PR_cursor	175
#define PR_ctime	176
#define PR_gc_usage	177
#define PR_format_print_float	178
#define PR_format_print_integer	179
#define PR_line_position	180
#define PR_line_count	181
#define PR_setenv	182
#define PR_suspend_th	183
#define PR_tcp_init	184
#define PR_socket	185
#define PR_setsockopt	186
#define PR_getsockopt	187
#define PR_bind		188
#define PR_listen	189
#define PR_accept	190
#define PR_connect1	191
#define PR_connect2	192
#define PR_send		193
#define PR_recv		194
#define PR_sendto	195
#define PR_recvfrom	196
#define PR_sendbr	197
#define PR_checkrecv	198
#define PR_checkconn	199
#define PR_tcp_close	200
#define PR_getsockaddr	201
#define PR_getpeeraddr	202
#define PR_gethost	203
#define PR_getport	204
#define PR_real_socket	205

extern bool	pr_add(),		/*  0 */
		pr_subtract(),		/*  1 */
		pr_multiply(),		/*  2 */
		pr_divide(),		/*  3 */
		pr_mod(),		/*  4 */
		pr_cmp(),		/*  5 */
		pr_integer(),		/*  6 */
		pr_atom(),		/*  7 */
		pr_var(),		/*  8 */
		pr_list(),		/*  9 */
		pr_tpl(),		/* 10 */
		pr_getarg(),		/* 11 */
		pr_tuple_to_list(),	/* 12 */
		pr_name(),		/* 13 */
		pr_open_stream(),	/* 14 */
		pr_close_stream(),	/* 15 */
		pr_open_ram(),		/* 16 */
		pr_close_ram(),		/* 17 */
		pr_set_input(),		/* 18 */
		pr_set_output(),	/* 19 */
		pr_increment(),		/* 20 */
		pr_put_q_atom(),	/* 21 */
/*
		pr_get0			   22	(charin)
		pr_put			   23	(charout)
		pr_unget		   24	(charback)
*/
		pr_flush(),		/* 25 */
		pr_addr(),		/* 26 */
/*
		pr_deepcut(),		   27
		pr_back(),		   28
*/
		pr_meta(),		/* 29 */
		pr_eq(),		/* 30 */
		pr_ne(),		/* 31 */
		pr_lt(),		/* 32 */
		pr_le(),		/* 33 */
		pr_gt(),		/* 34 */
		pr_ge(),		/* 35 */
		pr_syntax_error(),	/* 36 */
		pr_link(),		/* 37 */
		pr_retract(),		/* 38 */
		pr_dec(),		/* 39 */
		pr_inc(),		/* 40 */
		pr_find_clause(),	/* 41 */
		pr_time(),		/* 42 */
		pr_arity(),		/* 43 */
		pr_funct(),		/* 44 */
		pr_interm(),		/* 45 */
		pr_ntpl(),		/* 46 */
		pr_not(),		/* 47 */
		pr_lshift(),		/* 48 */
		pr_rshift(),		/* 49 */
		pr_and(),		/* 50 */
		pr_or(),		/* 51 */
		pr_op_prefix(),		/* 52 */
		pr_op_postfix(),	/* 53 */
		pr_op_infix(),		/* 54 */
		pr_op_look(),		/* 55 */
		pr_op_get(),		/* 56 */
		pr_put_str(),		/* 57 */
		pr_put_atom(),		/* 58 */
		pr_put_number(),	/* 59 */
		pr_atom_type(),		/* 60 */
		pr_defined(),		/* 61 */
/*
		pr_read_catch(),	   62
		pr_set_catch(),		   63
		pr_read_error(),	   64
		pr_catch(),		   65
		pr_throw(),		   66
*/
		pr_cg_init(),		/* 67 */
		pr_cg_fixup(),		/* 68 */
		pr_cg(),		/* 69 */
		pr_system(),		/* 70 */
		pr_ram_const(),		/* 71 */
		pr_load(),		/* 72 */
		pr_varsin(),		/* 73 */
		pr_fix_tables(),	/* 74 */
		pr_save(),		/* 75 */
		pr_pred_look(),		/* 76 */
		pr_pred_get(),		/* 77 */
		pr_abolish(),		/* 78 */
		pr_validate(),		/* 79 */
		pr_undo_seg(),		/* 80 */
		pr_kill(),		/* 81 */
		pr_write_term(),	/* 82 */
		pr_read_term(),		/* 83 */
		pr_tag(),		/* 84 */
		pr_grnd_funct(),	/* 85 */
		pr_tab(),		/* 86 */
		pr_concat(),		/* 87 */
		pr_prefix(),		/* 88 */
		pr_suffix(),		/* 89 */
		pr_to_ground(),		/* 90 */
		pr_to_hollow(),		/* 91 */
		pr_delete(),		/* 92 */
		pr_cg_out(),		/* 93 */
		pr_set_up_seg(),	/* 94 */
		pr_tty(),		/* 95 */
		pr_ram_pipe(),		/* 96 */
		pr_close_port(),	/* 97 */
		pr_read_pipe(),		/* 98 */
		pr_write_pipe(),	/* 99 */
		pr_new_thread(),	/* 100 */
		pr_kill_thread(),	/* 101 */
		pr_fork(),		/* 102 */
		pr_resume(),		/* 103 */
		pr_suspend(),		/* 104 */
		pr_rpc(),		/* 105 */
		pr_pipe(),		/* 106 */
		pr_thread(),		/* 107 */
		pr_set_prop(),		/* 108 */
		pr_get_prop(),		/* 109 */
		pr_del_prop(),		/* 110 */
		pr_get_props(),		/* 111 */
		pr_del_props(),		/* 112 */
		pr_get_cons(),		/* 113 */
		pr_del_cons(),		/* 114 */
		pr_float(),		/* 115 */
		pr_put_float(),		/* 116 */
		pr_number(),		/* 117 */
		pr_fadd(),		/* 118 */
		pr_fsub(),		/* 119 */
		pr_fmul(),		/* 120 */
		pr_fdiv(),		/* 121 */
		pr_int(),		/* 122 */
		pr_sin(),		/* 123 */
		pr_cos(),		/* 124 */
		pr_tan(),		/* 125 */
		pr_asin(),		/* 126 */
		pr_acos(),		/* 127 */
		pr_atan(),		/* 128 */
		pr_atan2(),		/* 129 */
		pr_sinh(),		/* 130 */
		pr_cosh(),		/* 131 */
		pr_tanh(),		/* 132 */
		pr_exp(),		/* 133 */
		pr_log(),		/* 134 */
		pr_log10(),		/* 135 */
		pr_sqrt(),		/* 136 */
		pr_pow(),		/* 137 */
		pr_abs(),		/* 138 */
		pr_sign(),		/* 139 */
		pr_ceil(),		/* 140 */
		pr_floor(),		/* 141 */
		pr_pi(),		/* 142 */
		pr_rand(),		/* 143 */
		pr_deg2rad(),		/* 144 */
		pr_rad2deg(),		/* 145 */
/*
		pr_interrupt(),		   146
*/
		pr_unix(),		/* 147 */
		pr_stat(),		/* 148 */
		pr_look_pipe(),		/* 149 */
		pr_commit_read(),	/* 150 */
		pr_unlock(),		/* 151 */
		pr_init_parlog(),	/* 152 */
		pr_tty_get0(),		/* 153 */
		pr_curr_input(),	/* 154 */
		pr_curr_output(),	/* 155 */
		pr_release_port(),	/* 156 */
		pr_empty_pipe(),	/* 157 */
		pr_is_iport(),		/* 158 */
		pr_is_oport(),		/* 159 */
		pr_runtime(),		/* 160 */
		pr_decrement(),		/* 161 */
/*
		pr_exit(),		   162
*/
		pr_set_port(),		/* 163 */
		pr_get_port(),		/* 164 */
		pr_gensym(),		/* 165 */
		pr_ar_int(),		/* 166 */
		pr_ar_float(),		/* 167 */
		pr_copy(),		/* 168 */
		pr_load_foreign(),	/* 170 */
		pr_realtime(),		/* 171 */
		pr_errno(),		/* 172 */
		pr_getenv(),		/* 173 */
		pr_timeslice(),		/* 174 */
		pr_cursor(),		/* 175 */
		pr_ctime(),		/* 176 */
		pr_gc_usage(),		/* 177 */
		pr_format_print_float(),		/* 178 */
		pr_format_print_integer(),		/* 179 */
		pr_line_position(),	/* 180 */
		pr_line_count(),	/* 181 */
		pr_setenv(),		/* 182 */
		pr_suspend_th(),	/* 183 */
		pr_tcp_init(),		/* 184 */
		pr_socket(),		/* 185 */
		pr_setsockopt(),	/* 186 */
		pr_getsockopt(),	/* 187 */
		pr_bind(),		/* 188 */
		pr_listen(),		/* 189 */
		pr_accept(),		/* 190 */
		pr_connect1(),		/* 191 */
		pr_connect2(),		/* 192 */
		pr_send(),		/* 193 */
		pr_recv(),		/* 194 */
		pr_sendto(),		/* 195 */
		pr_recvfrom(),		/* 196 */
		pr_sendbr(),		/* 197 */
		pr_checkrecv(),		/* 198 */
		pr_checkconn(),		/* 199 */
		pr_tcp_close(),		/* 200 */
		pr_getsockaddr(),	/* 201 */
		pr_getpeeraddr(),	/* 202 */
		pr_gethost(),		/* 203 */
		pr_getport(),		/* 204 */
		pr_real_socket();	/* 205 */

extern	bool	gc_test();
